import javax.swing.*;
import java.awt.event.*;
import java.awt.*;


public class MyDialogRect extends JDialog implements ActionListener {
    private JLabel labelX1= new JLabel("X1");
    private JLabel labelY1= new JLabel("Y1");

    private JLabel labelX2= new JLabel("X2");
    private JLabel labelY2= new JLabel("Y2");

    private JLabel labelLineWidth= new JLabel("Strichstrke");
    private JLabel labelColor= new JLabel("Farbe");

    private JTextField x1= new JTextField();
    private JTextField y1= new JTextField();
    private JTextField x2= new JTextField();
    private JTextField y2= new JTextField();
    private JTextField linewidth= new JTextField();
    private JPanel pColor= new JPanel();
    
    Rect rect;
    
    JButton BnOk;
    JButton BnESC;
    

    public boolean result;  // gibt an, ob Ok oder Esc gedrckt wurde

  public MyDialogRect( Frame parent, Rect rect) {
   super(parent);
   setModal(true);
   setTitle("Bearbeiten eines Rechtecks");
   setSize(600,300);
   result=false;
   this.rect = rect;
   setGUI();

   setVisible(true);

  }

  private void setGUI() {
        this.getContentPane().setLayout( new GridBagLayout() );
        
        x1.setText( Integer.toString(rect.x1) );
        y1.setText( Integer.toString(rect.y1) );
        x2.setText( Integer.toString(rect.x2) );
        y2.setText( Integer.toString(rect.y2) );
        linewidth.setText( Double.toString(rect.linewidth) );
        pColor.setBackground(rect.color);
        
       labelX1.setFont( new Font("Arial", Font.BOLD,18)  );
       labelY1.setFont( new Font("Arial", Font.BOLD,18)  );
       labelX2.setFont( new Font("Arial", Font.BOLD,18)  );
       labelY2.setFont( new Font("Arial", Font.BOLD,18)  );
       labelLineWidth.setFont( new Font("Arial", Font.BOLD,18)  );
       labelColor.setFont( new Font("Arial", Font.BOLD,18)  );

       x1.setFont( new Font("Arial", Font.BOLD,18)  );
       y1.setFont( new Font("Arial", Font.BOLD,18)  );
       x2.setFont( new Font("Arial", Font.BOLD,18)  );
       y2.setFont( new Font("Arial", Font.BOLD,18)  );
      
       linewidth.setFont( new Font("Arial", Font.BOLD,18)  );
       pColor.setPreferredSize( new Dimension(10,30));
       

      this.getContentPane().add(labelX1,
          new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
          GridBagConstraints.WEST, GridBagConstraints.NONE,
          new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(x1,
           new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------
      this.getContentPane().add(labelY1,
          new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0,
          GridBagConstraints.WEST, GridBagConstraints.NONE,
          new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(y1,
           new GridBagConstraints(3, 0, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------

      
      this.getContentPane().add(labelX2,
          new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
          GridBagConstraints.WEST, GridBagConstraints.NONE,
          new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(x2,
           new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------
      this.getContentPane().add(labelY2,
          new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0,
          GridBagConstraints.WEST, GridBagConstraints.NONE,
          new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(y2,
           new GridBagConstraints(3, 1, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------


      this.getContentPane().add(labelLineWidth,
          new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(linewidth,
           new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------

      this.getContentPane().add(labelColor,
          new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(pColor,
           new GridBagConstraints(3, 2, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      
      // -------------------------------

        JPanel pn = new JPanel();
        pn.setLayout( new FlowLayout() );


        BnOk = new JButton("Ok");
        BnOk.setFont( new Font("Arial", Font.BOLD,18)  );
        pn.add( BnOk);

        BnESC = new JButton("Abbruch");
        BnESC.setFont( new Font("Arial", Font.BOLD,18)  );
        pn.add( BnESC);

        // gleiche Groesse
        BnOk.setPreferredSize( BnESC.getPreferredSize() );
        
        this.getContentPane().add(pn,   
                new GridBagConstraints(0, 3, 4, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(25,0,0,0), 0, 0));

         BnOk.addActionListener(this);
         BnESC.addActionListener(this);
         
         pColor.addMouseListener(new java.awt.event.MouseAdapter() {
          public void mouseClicked(MouseEvent e) {
            chooseColor();
          }
        });
         
  } // setGUI

    @Override
   public void actionPerformed(ActionEvent e) {
     if (e.getSource() == BnOk) {           
      BnOk_click();
     }
     if (e.getSource() == BnESC) {           
      BnESC_click();
     }
    }
  
  private void BnESC_click() {
    result=false;
    setVisible(false);
    dispose();
  }

  private void BnOk_click() {
    result=true;
    // Speichern in variable line
    rect.x1 = Integer.parseInt(x1.getText() );
    rect.y1 = Integer.parseInt(y1.getText() );
    rect.x2 = Integer.parseInt(x2.getText() );
    rect.y2 = Integer.parseInt(y2.getText() );
    rect.linewidth = Float.parseFloat(linewidth.getText() );
    rect.color = pColor.getBackground();
    
    setVisible(false);
    dispose();
  }

 
    private void chooseColor() {
        Color newColor = JColorChooser.showDialog(
             this, "Linienfarbe",
             pColor.getBackground());
       if(newColor != null){
           pColor.setBackground(newColor);
       } 
    }
}
